using MSAdminUsuarios.Context;
using Microsoft.EntityFrameworkCore;
using Security;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.

builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

// Cadena de Conexion a Bases de Datos
var connectionString = builder.Configuration.GetConnectionString("DBPrueba");
// var connectionString = builder.Configuration.GetConnectionString("DBProd");

// Configuracin del DbContext
builder.Services.AddDbContext<ModelContext>(options =>
{
    options.UseOracle(
            connectionString,
            options => options.UseOracleSQLCompatibility("11")
        );
});

// Enable Cors
builder.Services.AddCors(options => {
    options.AddPolicy(name: "widthoutCors",
        builder => {
            builder.AllowAnyOrigin()
            .AllowAnyMethod()
            .AllowAnyHeader();
        });
});

var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment() || app.Environment.IsProduction())
{
    app.UseSwagger();
    app.UseSwaggerUI();
    app.UseCors("widthoutCors");
}

if(app.Environment.IsDevelopment())
{
    Environment.SetEnvironmentVariable("Mode", "Dev");
} else
{
    Environment.SetEnvironmentVariable("Mode", "Prod");
}

// app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
